"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const moment_1 = __importDefault(require("moment"));
const material_1 = require("@mui/material");
const PhotoCameraOutlined_1 = __importDefault(require("@mui/icons-material/PhotoCameraOutlined"));
const ReactImageFileToBase64 = ({ onCompleted, multiple, CustomisedButton, preferredButtonText, }) => {
    const inputRef = (0, react_1.useRef)(null);
    //TRIGGERS THE FILE TO OPEN DEVICE FOLDER FOR IMAGE SELECTION
    const handleFilesSelection = () => {
        var _a;
        inputRef.current.value = "";
        (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.click();
    };
    const handleOnInputFileChange = (event) => {
        const selectedFiles = event.target.files;
        const base64Files = [];
        //event.target.files  RETURN A FILELIST TYPE WHICH IS AN OBJECT
        //CONVERT SELECTED FILES DOCUMENT TO ARRAY AND MAP THROUGH
        Array.from(selectedFiles).map((file) => {
            //DOUBLE CHECK IF FILE TYPE MATCHES ACCEPTED EXTENSION CRITERIA
            if (!/\.(jpeg|jpg|png|gif)$/i.test(file.name))
                return console.log("blah");
            const reader = new FileReader();
            reader.readAsDataURL(file);
            return (reader.onload = () => {
                //OBJECT OF FILE THAT'LL BE RETURNED TO THE USER
                const fileInfo = {
                    file_name: file === null || file === void 0 ? void 0 : file.name,
                    file_size: `${Math.round(file.size / 1000)} KB`,
                    file_type: file === null || file === void 0 ? void 0 : file.type,
                    last_modified: (0, moment_1.default)(file.lastModified).format(),
                    base64_file: reader.result,
                    default_file: file,
                };
                base64Files.push(fileInfo);
                if (base64Files.length === Array.from(selectedFiles).length) {
                    onCompleted(base64Files);
                }
            });
        });
    };
    return (react_1.default.createElement("label", { htmlFor: "select_images", className: "react-image-file-to-base64" },
        react_1.default.createElement("input", { type: "file", name: "create_media_input", id: "create_media_input", accept: "image/png, .jpeg, .jpg, .gif", ref: inputRef, multiple: multiple, onChange: handleOnInputFileChange, style: { display: "none" } }),
        CustomisedButton ? (react_1.default.createElement(CustomisedButton, { triggerInput: handleFilesSelection })) : (react_1.default.createElement(material_1.Button, { variant: "contained", onClick: handleFilesSelection, style: { textTransform: "initial" } },
            react_1.default.createElement(PhotoCameraOutlined_1.default, { style: { marginRight: "7px" } }),
            preferredButtonText ? preferredButtonText : "Select files"))));
};
exports.default = ReactImageFileToBase64;
ReactImageFileToBase64.defaultProps = {
    multiple: false,
};
//# sourceMappingURL=index.js.map